<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<ng-container *ngFor="let group of appTextBlockGroups; trackBy: trackBy; let groupIndex = index;">
  <ng-template #headerTemplateRef>
    <div class="group-header">

      <input #groupNameInputElement
             (focusout)="appSelectedGroupIndex = undefined"
             (input)="appGroupNameChange.emit({groupIndex: groupIndex, groupName: groupNameInputElement.value})"
             (keydown.enter)="groupNameInputElement.blur()"
             (keydown.escape)="groupNameInputElement.blur()"
             *ngIf="groupIndex === appSelectedGroupIndex"
             [disabled]="appDisabled"
             [value]="group.groupName"
             appAutoFocusAfterInit
             autocomplete="off"
             class="openk-input group-header--input">

      <button (click)="appDeleteTextBlockGroup.emit({ groupIndex: groupIndex })"
              *ngIf="appSelectedGroupIndex !== groupIndex"
              [disabled]="appDisabled" class="openk-button openk-button-icon group-header--button"
              style="margin-right: auto;"
              type="button">
        <mat-icon>delete_forever</mat-icon>
      </button>

      <button (click)="appSelectedGroupIndex = groupIndex"
              *ngIf="appSelectedGroupIndex !== groupIndex"
              [disabled]="appDisabled"
              class="openk-button openk-button-icon group-header--button"
              type="button">
        <mat-icon>edit</mat-icon>
      </button>

      <button *ngIf="appSelectedGroupIndex === groupIndex"
              [disabled]="appDisabled"
              class="openk-button openk-button-icon group-header--button"
              type="button">
        <mat-icon>edit</mat-icon>
      </button>

      <button (click)="appAddTextBlockGroup.emit({ groupIndex: groupIndex }); appSelectedGroupIndex = groupIndex + 1;"
              [disabled]="appDisabled"
              class="openk-button openk-button-icon group-header--button"
              type="button">
        <mat-icon>add</mat-icon>
      </button>
    </div>
  </ng-template>

  <app-collapsible
    [appHeaderTemplateRef]="headerTemplateRef"
    [appSimpleCollapsible]="true"
    [appTitle]="appSelectedGroupIndex === groupIndex ? '' : group.groupName"
    class="text-block-group">
    <app-text-block-list
      (appAdd)="appCreateTextBlock.emit({ textBlock: $event.textBlock, index: $event.index, groupIndex: groupIndex})"
      (appDelete)="appDeleteTextBlock.emit({ textBlock: $event.textBlock, index: $event.index, groupIndex: groupIndex})"
      (appDown)="appMoveTextBlock.emit({ groupIndex: groupIndex, from: $event.index, to: $event.index + 1})"
      (appEdit)="appEditTextBlock.emit({ textBlock: $event.textBlock, index: $event.index, groupIndex: groupIndex})"
      (appUp)="appMoveTextBlock.emit({ groupIndex: groupIndex, from: $event.index, to: $event.index - 1})"
      [appConnectedTo]="appConnectedTo"
      [appDisabled]="appDisabled"
      [appDuplicateOnDrag]="true"
      [appForAdmin]="true"
      [appListData]="group.textBlocks"
      [appReplacements]="appReplacements"
      [appSelectedIds]="[appSelectedId]"
      [appShowPreview]="true"
      class="openk-drag-list-with-hidden-placeholder">
    </app-text-block-list>
  </app-collapsible>
</ng-container>

